Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-2x.cfg	(revision 817)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-2x.cfg	(revision 849)
@@ -22,6 +22,10 @@
 IntraPeriod1                  : 64          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
-ScaledRefLayerId1             : 0           # Scaled reference layer ID
-ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
+NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
+ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
+RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
+RefRegionBottomOffset1           : 2        # List of ref region bottom offsets
+ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
+
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-SNR.cfg	(revision 817)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-SNR.cfg	(revision 849)
@@ -22,6 +22,9 @@
 IntraPeriod1                  : 64          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
-ScaledRefLayerId1             : 0           # Scaled reference layer ID
-ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
+NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
+ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
+RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
+RefRegionBottomOffset1           : 4        # List of ref region bottom offsets
+ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-2x.cfg	(revision 817)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-2x.cfg	(revision 849)
@@ -22,6 +22,10 @@
 IntraPeriod1                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
-ScaledRefLayerId1             : 0           # Scaled reference layer ID
-ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
+NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
+ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
+RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
+RefRegionBottomOffset1           : 2        # List of ref region bottom offsets
+ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
+
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-SNR.cfg	(revision 817)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-SNR.cfg	(revision 849)
@@ -22,6 +22,9 @@
 IntraPeriod1                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
-ScaledRefLayerId1             : 0           # Scaled reference layer ID
-ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
+NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
+ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
+RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
+RefRegionBottomOffset1           : 4        # List of ref region bottom offsets
+ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-2x.cfg	(revision 817)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-2x.cfg	(revision 849)
@@ -22,6 +22,10 @@
 IntraPeriod1                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
-ScaledRefLayerId1             : 0           # Scaled reference layer ID
-ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
+NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
+ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
+RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
+RefRegionBottomOffset1           : 2        # List of ref region bottom offsets
+ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
+
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-SNR.cfg	(revision 817)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-SNR.cfg	(revision 849)
@@ -22,6 +22,9 @@
 IntraPeriod1                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
-ScaledRefLayerId1             : 0           # Scaled reference layer ID
-ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
+NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
+ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
+RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
+RefRegionBottomOffset1           : 4        # List of ref region bottom offsets
+ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-2x.cfg	(revision 817)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-2x.cfg	(revision 849)
@@ -22,6 +22,9 @@
 IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
-ScaledRefLayerId1             : 0           # Scaled reference layer ID
-ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
+NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
+ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
+RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
+RefRegionBottomOffset1           : 2        # List of ref region bottom offsets
+ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-SNR.cfg	(revision 817)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-SNR.cfg	(revision 849)
@@ -22,6 +22,9 @@
 IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
-ScaledRefLayerId1             : 0           # Scaled reference layer ID
-ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
+NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
+ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
+RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
+RefRegionBottomOffset1           : 4        # List of ref region bottom offsets
+ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-2x.cfg	(revision 817)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-2x.cfg	(revision 849)
@@ -22,6 +22,9 @@
 IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
-ScaledRefLayerId1             : 0           # Scaled reference layer ID
-ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
+NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
+ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
+RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
+RefRegionBottomOffset1           : 2        # List of ref region bottom offsets
+ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-SNR.cfg	(revision 817)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-SNR.cfg	(revision 849)
@@ -22,6 +22,9 @@
 IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
-ScaledRefLayerId1             : 0           # Scaled reference layer ID
-ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
+NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
+ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
+RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
+RefRegionBottomOffset1           : 4        # List of ref region bottom offsets
+ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
Index: branches/SHM-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg	(revision 817)
+++ branches/SHM-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg	(revision 849)
@@ -24,2 +24,10 @@
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
+
+#============= Reference location offset parameters ==================
+NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
+ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
+RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
+RefRegionBottomOffset1           : 2        # List of ref region bottom offsets
+ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
Index: branches/SHM-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg	(revision 817)
+++ branches/SHM-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg	(revision 849)
@@ -24,2 +24,10 @@
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
+
+#============= Reference location offset parameters ==================
+NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
+ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
+RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
+RefRegionBottomOffset1           : 2        # List of ref region bottom offsets
+ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
Index: branches/SHM-dev/cfg/per-sequence-svc/Cactus-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/Cactus-2x.cfg	(revision 817)
+++ branches/SHM-dev/cfg/per-sequence-svc/Cactus-2x.cfg	(revision 849)
@@ -24,2 +24,10 @@
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
+
+#============= Reference location offset parameters ==================
+NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
+ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
+RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
+RefRegionBottomOffset1           : 2        # List of ref region bottom offsets
+ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
Index: branches/SHM-dev/cfg/per-sequence-svc/Kimono-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 817)
+++ branches/SHM-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 849)
@@ -24,2 +24,10 @@
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
+
+#============= Reference location offset parameters ==================
+NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
+ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
+RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
+RefRegionBottomOffset1           : 2        # List of ref region bottom offsets
+ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
Index: branches/SHM-dev/cfg/per-sequence-svc/ParkScene-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 817)
+++ branches/SHM-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 849)
@@ -24,2 +24,10 @@
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
+
+#============= Reference location offset parameters ==================
+NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
+ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
+RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
+RefRegionBottomOffset1           : 2        # List of ref region bottom offsets
+ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags